Page MenuHomeFreeBSD

[PPC64] Fix rtld direct exec mode
ClosedPublic

Authored by luporl on Aug 1 2019, 8:38 PM.

Details

Summary

Instead of restoring the saved values of argc, argv and envp,
these must be loaded from the stack that _rtld() modifies.

This fixes rtld direct exec mode.
E.g.: /libexec/ld-elf.so.1 /bin/ls

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

luporl created this revision.Aug 1 2019, 8:38 PM
jhibbits accepted this revision.Aug 3 2019, 11:58 AM

Looks good. Can the same change apply to powerpc?

This revision is now accepted and ready to land.Aug 3 2019, 11:58 AM
luporl added a comment.Aug 5 2019, 1:18 PM

Looks good. Can the same change apply to powerpc?

A brief look at powerpc/rtld_start.S code seems to indicate that the same changes apply to powerpc.

But it would be better for someone with 32-bit powerpc hardware to make the change and confirm it works fine.

This revision was automatically updated to reflect the committed changes.